=== debian/changelog ===
drbd8 (2:8.4.4-1ubuntu1) trusty; urgency=medium

  * debian/patches/ppc64el-ftbfs.patch: Fix build failure on ppc64el.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 13 Feb 2014 18:40:32 -0800

drbd8 (2:8.4.4-1) unstable; urgency=low

  * New upstream version (Closes: #714210, #721443, #711781)
  * Do not participate in the usage count by default (Closes: #711352)
  * Basic systemd support
  * Bump compat to 9 and standards to 3.9.5
  * Convert to dh sequencer
    + use dh_installinit for the initscript and use the default ordering
     (Closes: #476544)
  * Two new patches, fixing automatic chainloading of legacy drbdsetup when
    kernel DRBD is 8.3:
    + 0001-drbdsetup-use-lib-drbd-drbdsetup-83.patch
    + 0002-drbdsetup-delay-exiting-due-to-unknown-commands.patch
  * Convert copyright to Format 1.0
  * Remove unnecessary (build-)dependencies:
    bison, bzip2, debconf
  * Fix Vcs-Git URL

 -- Apollon Oikonomopoulos <apoikos@gmail.com>  Thu, 07 Nov 2013 14:02:13 +0200
