=== debian/control ===
Source: drbd8
Section: admin
Priority: extra
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian DRBD Maintainers <debian-ha-maintainers@lists.alioth.debian.org>
Uploaders: Norbert Tretkowski <norbert@tretkowski.de>,
 Martin Loschwitz <madkiss@debian.org>,
 Philipp Hug <debian@hug.cx>,
 Apollon Oikonomopoulos <apoikos@gmail.com>
Build-Depends: debhelper (>= 9), flex, xsltproc, git, dh-systemd (>= 1.5)
Standards-Version: 3.9.5
Homepage: http://www.drbd.org/
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=debian-ha/drbd.git
Vcs-Git: git://anonscm.debian.org/debian-ha/drbd/

Package: drbd8-utils
Architecture: linux-any
Depends: ${shlibs:Depends}, ${misc:Depends}, ${perl:Depends}
Conflicts: drbd-utils
Provides: drbd-utils
Replaces: drbd-utils, drbd
Suggests: heartbeat
Recommends: heirloom-mailx|mailx
Description: RAID 1 over TCP/IP for Linux (user utilities)
 Drbd is a block device which is designed to build high availability
 clusters by providing a virtual shared device which keeps disks in
 nodes synchronised using TCP/IP. This simulates RAID 1 but avoiding
 the use of uncommon hardware (shared SCSI buses or Fibre Channel).
 It is currently limited to fail-over HA clusters.
 .
 This package contains the programs that will control the drbd kernel
 module provided in the Linux kernel.
