=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Uncomment this to turn on verbose mode.
# export DH_VERBOSE=1

%:
	dh $@ --with systemd

override_dh_auto_clean:
	dh_auto_clean
	rm -f debian/drbd8-utils.drbd.init

override_dh_auto_configure:
	./configure --prefix=/usr --localstatedir=/var --sysconfdir=/etc \
		--sbindir=/sbin --with-utils --with-udev --with-xen \
		--with-pacemaker --with-rgmanager --with-bashcompletion


override_dh_install:
	dh_install --fail-missing

	# Move udev rule to /lib/udev/rules.d (Fixes lintian warning)
	mv $(CURDIR)/debian/drbd8-utils/etc/udev/rules.d/* $(CURDIR)/debian/drbd8-utils/lib/udev/rules.d/
	rm -r $(CURDIR)/debian/drbd8-utils/etc/udev

	# Move drbd-overview to /usr/sbin
	mv $(CURDIR)/debian/drbd8-utils/sbin/drbd-overview $(CURDIR)/debian/drbd8-utils/usr/sbin/

	# Place the initscript where dh_installinit can find it
	mv $(CURDIR)/debian/drbd8-utils/etc/init.d/drbd $(CURDIR)/debian/drbd8-utils.drbd.init


override_dh_installinit:
	dh_installinit --name=drbd --no-start


.PHONY: override_dh_auto_configure override_dh_install \
	override_dh_auto_clean override_dh_installinit
