=== debian/watch ===
version=3
http://oss.linbit.com/drbd/ 8.3/drbd-(.*).tar.gz
